#!/usr/bin/perl
# Data preprocessing: codeSplit filename col
#
# Written by Krung Sinapiromsaran, 4 July 2007

# Extract initial setting
$filename = $ARGV[0];
$col = $ARGV[1];

$outfilename = "codeSplit" . $col . $filename;

# Preprocess col
open(FD, $filename) || die "Error in $filename\n";
   $headerline = <FD>;
   $firstDataline = <FD>;
close(FD);
# Extract the name of the col
@header = split("\,", $headerline);
$name = $header[$col];
$name =~ s/\"//g;

@line = split("\,", $firstDataline);
$line[$col] =~ s/\"//g;
$n = length($line[$col]);

# Start a selection process
open(FD, $filename) || die "Error in $filename\n";
open(OUTFD, ">$outfilename") || die "Cannot write $outfilename";
 
 # Keep the first line (header row) of data
 $firstline = <FD>; 
 chomp($firstline);
 print OUTFD $firstline;
 foreach $i (1..$n) {print OUTFD ", \"$name\_$i\"";}
 print OUTFD "\n";
 
$keep = $,;
$, = "\,";
 while($line = <FD>) {
     chomp($line);
     @lines = split("\,", $line);
	 $temp = $lines[$col];
	 $temp =~ s/\"//g;
	 @temp = split("", $temp);
	
	 $line .= ",";
	 print OUTFD $line;
     print OUTFD @temp;
	 print OUTFD "\n";
 }
$, = $keep; 
close(OUTFD);
close(FD);
print "$outfilename has been created\n";

