#!/usr/bin/perl
# Data preprocessing: convertColumn.pl filename col datavalue 
#
# Written by Krung Sinapiromsaran, 4 July 2007

# Extract initial setting
$filename = $ARGV[0];
$col = $ARGV[1];
$dataFilename = $ARGV[2];

$outfilename = "convert" . $col . $filename;

# Read datavalue file
%values = ();
open(IN, $dataFilename) || die "Cannot read $dataFilename $!\n";
   while(<IN>) {
       chomp; s/\s//g;
      ($i, $v) = split("\,");
	  $i =~ s/\W//g;
	  $values{$i} = $v;
	}
close(IN);

#print "\n@valueIndex\n@values\n";
#exit;
# Start a selection process
open(FD, $filename) || die "Error in $filename\n";
open(OUTFD, ">$outfilename") || die "Cannot write $outfilename";
 
 # Keep the first line (header row) of data
 $firstline = <FD>; print OUTFD $firstline;
 $keep = $,;
 $, = "\,";
 # The rest of data file
 while($line = <FD>) { 
   @lineData = split("\,", $line);
   $lineData[$col] =~ s/\"//g;
   $lineData[$col] = "\"" . $values{$lineData[$col]} . "\"";
   print OUTFD @lineData;
 }
close(OUTFD);
close(FD);
$, = $keep;
print "$outfilename has been created\n";

