#!/usr/bin/perl
# Data preprocessing:
#
# Transform by mapping 1 = Jan, ..., 12 = Dec

die "Usage: transformdate.pl filename\n" if($#ARGV < 0);
$filename = ($ARGV[0])?$ARGV[0]:"ACC47.csv";
$outfilename = "month" . $filename;

# Renaming months
@months = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

# Start openning file
open(FD, $filename) || die "Cannot read $filename $!\n";
open(OUTFD, ">$outfilename") || die "Cannot write $outfilename";
 
 # Keep the first line of data
 $firstline = <FD>;  print OUTFD $firstline;
 
 # Determine the "DATE2" index
 @header = split("\,", $firstline);
 foreach $i (0..$#header) {  $index = $i if $header[$i] =~ /DATE2/; }
 print $index, "\n";
 
 # The rest of data file
 while($line = <FD>) {
 @wholeline = split("\,", $line);
 $wholeline[$index] = "\"" . $months[$wholeline[$index] - 1] . "\"";
 $temp = "";
    foreach $i (@wholeline) { $temp .= "$i,"; }
	chop($temp);
	print OUTFD $temp, "\n";
 }
close(OUTFD);
close(FD);
print "Create $outfilename\n";

